package org.enhydra.shark.wrd;

import java.io.Serializable;
import java.util.*;

public class ActivityExecutionCounter extends HashMap implements Serializable, Cloneable {

   public void updateExecutionCount(String actDefId) {
      if (actDefId==null) throw new RuntimeException();
      Counter count=(Counter)get(actDefId);
      if (count!=null) {
         count.increment();
      } else {
         count=new Counter();
         count.increment();
      }
      put(actDefId,count);

   }

   public int getExecutionCount (String actDefId) {
      if (actDefId==null) throw new RuntimeException();
      Counter count=(Counter)get(actDefId);
      if (count!=null) {
         return count.value();
      } else {
         return 0;
      }
   }

   public String toString () {
      return "The content of EC is "+super.toString();
   }

   public boolean equals (Object obj) {
      if (!(obj instanceof ActivityExecutionCounter)) return false;
      ActivityExecutionCounter aec=(ActivityExecutionCounter)obj;
      if (aec.size()!=size()) return false;
      Iterator i=aec.entrySet().iterator();
      while (i.hasNext()) {
         Map.Entry me=(Map.Entry)i.next();
         String key=(String)me.getKey();
         Counter c=(Counter)me.getValue();
         Counter cOrig=(Counter)get(key);
         if (cOrig==null || !c.equals(cOrig)) {
            return false;
         }
      }
      return true;
   }

   public Object clone () {
      try {
         ActivityExecutionCounter aec=(ActivityExecutionCounter)super.clone();
         aec.clear();
         Iterator it=this.entrySet().iterator();
         while (it.hasNext()) {
            Map.Entry me=(Map.Entry)it.next();
            aec.put(me.getKey(),((Counter)me.getValue()).clone());
         }
         return aec;
      } catch (Exception ex) {
         return null;
      }
   }

}
